#include "SPI.h"

#define VCC  8
#define GND  9
#define SLAVE  10

byte enabled = 255;

void SPI_disable() {
  if (enabled != 255) {
    digitalWrite(enabled, HIGH);
    enabled = 255;
  }
}

void SPI_enable(byte slaveselecter) {
  SPI_disable();
  digitalWrite(slaveselecter, LOW);
  enabled = slaveselecter;
}

byte SPI_read(){
   return SPI.transfer(0x00);
}

void setup() {
#ifdef GND
  pinMode(GND, OUTPUT);
  digitalWrite(GND, LOW); 
#endif
#ifdef VCC
  pinMode(VCC, OUTPUT);
  digitalWrite(VCC, HIGH);
#endif
  pinMode(SLAVE, OUTPUT);
  digitalWrite(SLAVE, HIGH);

  Serial.begin(9600);
//  SPI_Master.begin(SLAVE);
  SPI.begin();
  SPI.setBitOrder(MSBFIRST);
  SPI.setClockDivider(SPI_CLOCK_DIV4);
  SPI.setDataMode(SPI_MODE0);
}

void loop() {
  int value;

  delay(500);
  SPI_enable(SLAVE);        //  SPI_Master.enable(SLAVE);
  value = SPI_read() << 8;  //  value = SPI_Master.read() << 8;
  value |= SPI_read();      //  value |= SPI_Master.read();
  SPI_disable();            //  SPI_Master.disable();
  
  if ((value & 0x0004) != 0){
    Serial.println("Error");
  } else {
    Serial.println((value >> 3) * 0.25);
  }
}

